uniform float t;
uniform float beat;
uniform float bounce;
uniform float kick;
uniform float saw;
uniform float id;
uniform float piece;

uniform vec3 fog_color;

uniform mat4 matrix;

#ifdef vertexcompile

layout (location=0) in vec3 pos;
layout (location=1) in vec3 nor;
smooth out vec3 ppos, pnor;

void main()
{

	ppos = pos;
	ppos *= 3.0;
	ppos.xyz *= 2.0;
	ppos.xz *= piece;
	float tt = t*0.1*0 + id * 2.0 ;
	ppos.y += tt*5;
	ppos.z += id * 2.0 + 10.0;
	ppos.x += cos(id * 1.3) * 800.0;
	ppos.z += sin(id * 1.3) * 800.0  + 5.0;
	ppos.xz/=ppos.y;
	ppos.xz+=vec2(cos(id * 1.3+beat), sin(id * 1.3+beat))*40;
	ppos.y += 150+sin(tt)*80;
	gl_Position = matrix*vec4(ppos, 1.0);
}

#endif

#ifdef fragmentcompile

smooth in vec3 pnor, ppos;
layout (location=0) out vec4 outcol;

uniform sampler2D tex, moss;

void main()
{
	float fogFalloff = 1.9; // smaller is thicker
	float fogScale = 1.99; // bigger is thicker
	float fogAmount = pow(abs((ppos.z * fogScale)) , fogFalloff); 

	outcol = vec4(0.8,0.3,0.1,0.0)*6/piece+vec4(0.0,0.0,0.0,0.6-piece*0.1);//l*abs(pnor.x)*texture2D(tex, ppos.yz*.1)+ys+l*abs(pnor.z)*texture2D(tex, ppos.xy*.1)+vec4(vec3(.0),1.0);
}
#endif
